package dk.nsp.xdscleanup.model;

import dk.nsp.xdscleanup.model.xds.TypeCode;

import java.time.Instant;
import java.time.Period;
import java.time.ZonedDateTime;

public class DocumentTypeCleanupSpecification {
    private TypeCode typeCode;

	private int numberOfMonthsToKeep;
	
	public DocumentTypeCleanupSpecification(TypeCode typeCode, int numberOfMonthsToKeep) {
		this.typeCode = typeCode;
		this.numberOfMonthsToKeep = numberOfMonthsToKeep;
	}

    public TypeCode getTypeCode() {
        return typeCode;
    }

    public Instant getLimit() {
        return ZonedDateTime
                .now()
                .minus(Period.ofMonths(numberOfMonthsToKeep))
                .toInstant();
	}
}
