package dk.nsp.xdscleanup.service.impl;

import java.util.List;

import dk.nsp.xdscleanup.model.DeletedDocumentEntry;
import dk.nsp.xdscleanup.model.DocumentTypeCleanupSpecification;
import dk.nsp.xdscleanup.service.CleanupService;
import dk.nsp.xdscleanup.service.RegistryCleanupService;
import dk.nsp.xdscleanup.service.RepositoryCleanupService;

public class CleanupServiceImpl implements CleanupService {

	private RepositoryCleanupService repositoryCleanupService;
	
	private RegistryCleanupService registryCleanupService;
	
	private int batchSize;
	
	private List<DocumentTypeCleanupSpecification> documentTypeCleanupSpecifications;
	
	public CleanupServiceImpl(RegistryCleanupService registryCleanupService, RepositoryCleanupService repositoryCleanupService, List<DocumentTypeCleanupSpecification> documentTypeCleanupSpecifications, int batchSize) {
		this.registryCleanupService = registryCleanupService;
		this.repositoryCleanupService = repositoryCleanupService;
		this.batchSize = batchSize;
		this.documentTypeCleanupSpecifications = documentTypeCleanupSpecifications;
	}
	
	public void cleanup() {
		
		// Sletter documententries for hver af de angivne typer
		if (documentTypeCleanupSpecifications != null) {
			for (DocumentTypeCleanupSpecification documentTypeCleanupSpecification : documentTypeCleanupSpecifications) {

                registryCleanupService.deleteRegistryData(documentTypeCleanupSpecification.getTypeCode(), documentTypeCleanupSpecification.getLimit(), batchSize);
			}
		}

		// Finder documenter der skal slettes i repository
		List<DeletedDocumentEntry> documentEntriesDeleted = registryCleanupService.findDeletedDocumentEntries(batchSize);
		List<DeletedDocumentEntry> documentsActuallyDeleted = repositoryCleanupService.deleteDocuments(documentEntriesDeleted);
		registryCleanupService.markDeletionComplete(documentEntriesDeleted);
	}

}
