package dk.nsp.xdscleanup.util;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.springframework.context.annotation.AnnotationConfigApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Import;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.support.PropertySourcesPlaceholderConfigurer;

import dk.nsp.xdscleanup.config.CleanupConfig;

public class XdsCleanupContextListener implements ServletContextListener {

	public static final String ANNOTATION_CONFIG_CONTEXT = "ANNOTATION_CONFIG_APPLICATION_CONTEXT";

	@Override
	public void contextInitialized(ServletContextEvent sce) {
		AnnotationConfigApplicationContext applicationContext = new AnnotationConfigApplicationContext();
		applicationContext.register(XdsCleanupProdConfiguration.class);
		applicationContext.refresh();

		sce.getServletContext().setAttribute(ANNOTATION_CONFIG_CONTEXT, applicationContext);
	}

	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		Object ctx = sce.getServletContext().getAttribute(ANNOTATION_CONFIG_CONTEXT);
		if(ctx instanceof AnnotationConfigApplicationContext) {
			((AnnotationConfigApplicationContext)ctx).close();
		}
	}

	@Configuration
	@PropertySource("classpath:xdscleanup.properties")
	@Import(CleanupConfig.class)
	public static class XdsCleanupProdConfiguration {
		
		@Bean 
		public static PropertySourcesPlaceholderConfigurer propertySourcesPlaceholderConfigurer() {
			return new PropertySourcesPlaceholderConfigurer();
		}
	}


}
