package dk.nsp.xdscleanup.ws;

import dk.nsp.xdscleanup.service.CleanupService;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;

import javax.servlet.ServletOutputStream;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;

@WebServlet(name="CleanupServlet", urlPatterns={"/cleanup"})
public class CleanupServlet extends AbstractCleanupServlet {
    private static final Logger log = Logger.getLogger(CleanupServlet.class);

    @Autowired
    private CleanupService cleanupService;

    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        log.info("Performing iteration of XDS Cleanup ...");

        int status = 200;
        try {
            cleanupService.cleanup();
        }
        catch(Exception e) {
            log.error("Error performing XDS Cleanup", e);
            status = 500;
        }
        response.setStatus(status);
    }
}
