package dk.nsp.xdscleanup.config;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.lookup.JndiDataSourceLookup;

@Configuration
public class DataSourceConfiguration {

    @Value("${datasource.nxrg.jndi.name}")
    private String nxrgJndiName;

    @Value("${datasource.openxds.jndi.name}")
    private String openXdsJndiName;

    @Bean(name = "nxrgDataSource")
    public DataSource getNxrgDataSource() {
        return new JndiDataSourceLookup().getDataSource(nxrgJndiName);
    }

    @Bean(name = "openxdsDataSource")
    public DataSource getOpenxdsDataSource() {
        return new JndiDataSourceLookup().getDataSource(openXdsJndiName);
    }
}
