package dk.nsp.xdscleanup.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.PropertySource;

import dk.nsp.xdscleanup.util.HealthIndicator;
import dk.nsp.xdscleanup.util.VersionIndication;

@Configuration
@PropertySource("git.properties")
public class VersionConfiguration {

	@Value("${git.commit.id}")
	private String version;

	@Bean
	public HealthIndicator versionIndicator() {
		return new VersionIndication(version);
	}
}
