package dk.nsp.xdscleanup.config;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import dk.nsp.xdscleanup.dao.NxrgDao;
import dk.nsp.xdscleanup.dao.impl.NxrgDaoImpl;
import dk.nsp.xdscleanup.service.RegistryCleanupService;
import dk.nsp.xdscleanup.service.impl.RegistryCleanupServiceImpl;

@Configuration
@EnableTransactionManagement
public class NxrgCleanupConfiguration {

	private DataSource dataSource;
	
	public NxrgCleanupConfiguration(@Autowired @Qualifier("nxrgDataSource") DataSource dataSource) {
		this.dataSource = dataSource;
	}
	
    @Bean(name="tx-nxrg")
    public PlatformTransactionManager getTransactionManager() {
        return new DataSourceTransactionManager(dataSource);
    }

    @Bean
    public RegistryCleanupService registryCleanupService(NxrgDao nxrgDao) {
    	return new RegistryCleanupServiceImpl(nxrgDao);
    }
    
    @Bean
    public NxrgDao nxrgDao() {
    	return new NxrgDaoImpl(dataSource);
    }
}
