package dk.nsp.xdscleanup.dao;

import dk.nsp.xdscleanup.model.DeletedAssociation;
import dk.nsp.xdscleanup.model.DeletedDocumentEntry;
import dk.nsp.xdscleanup.model.DeletedSubmissionSet;
import dk.nsp.xdscleanup.model.xds.TypeCode;

import java.time.Instant;
import java.util.List;

public interface NxrgDao {
    List<DeletedDocumentEntry> getDocumentEntriesForDeletion(TypeCode typeCode, Instant latestStartTime, int batchSize);

    List<DeletedAssociation> getAssociationsForDocumentEntries(List<String> documentEntryUuids);

    List<DeletedSubmissionSet> filterEmptySubmissionSets(List<String> submissionSetEntryUuids, List<String> documentEntryUuids);

    void deleteDocumentEntries(List<String> documentEntryUuids);

    void deleteAssociations(List<String> associationEntryUuids);

    void deleteSubmissionSets(List<String> submissionSetUuids);

    void markDocumentEntriesDeletedFromRegistry(List<String> documentEntryUuids);

    List<DeletedDocumentEntry> getDocumentEntriesForRepositoryDeletion(int batchSize);

    void markDocumentEntriesDeletedFromRepository(List<String> documentEntryUuids);
}
