package dk.nsp.xdscleanup.dao.impl;

import java.time.Instant;
import java.util.LinkedList;
import java.util.List;

import javax.sql.DataSource;

import dk.nsp.xdscleanup.model.DeletedAssociation;
import dk.nsp.xdscleanup.model.DeletedSubmissionSet;
import dk.nsp.xdscleanup.model.xds.TypeCode;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;

import dk.nsp.xdscleanup.dao.NxrgDao;
import dk.nsp.xdscleanup.model.DeletedDocumentEntry;
import dk.nsp.xdscleanup.util.HealthIndication;
import dk.nsp.xdscleanup.util.HealthIndicator;

public class NxrgDaoImpl implements NxrgDao, HealthIndicator {

	private DataSource dataSource;
	
	public NxrgDaoImpl(DataSource dataSource) {
		this.dataSource = dataSource;
	}

    @Override
    public List<DeletedDocumentEntry> getDocumentEntriesForDeletion(TypeCode typeCode, Instant latestStartTime, int batchSize) {
        throw new UnsupportedOperationException();
    }

    @Override
    public List<DeletedAssociation> getAssociationsForDocumentEntries(List<String> documentEntryUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public List<DeletedSubmissionSet> filterEmptySubmissionSets(List<String> submissionSetEntryUuids, List<String> documentEntryUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void deleteDocumentEntries(List<String> documentEntryUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void deleteAssociations(List<String> associationEntryUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void deleteSubmissionSets(List<String> submissionSetUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void markDocumentEntriesDeletedFromRegistry(List<String> documentEntryUuids) {
        throw new UnsupportedOperationException();
    }

    @Override
    public List<DeletedDocumentEntry> getDocumentEntriesForRepositoryDeletion(int batchSize) {
        throw new UnsupportedOperationException();
    }

    @Override
    public void markDocumentEntriesDeletedFromRepository(List<String> documentEntryUuids) {
        throw new UnsupportedOperationException();
    }

    public HealthIndication getHealthInfo() {
		
		String registryDb = "registry.db";
		
		JdbcTemplate template = new JdbcTemplate(dataSource);
		try {
			template.queryForObject("select 1", Integer.class);
		} catch (DataAccessException e) {
			return new HealthIndication(500, "\""+registryDb+"\": \"ERROR\"");
		}
		return new HealthIndication(200, "\""+registryDb+"\": \"OK\"");
	}
}
