package dk.nsp.xdscleanup.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabase;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;

@Configuration
public class EmbeddedDatabaseConfiguration {

	@Bean
	public EmbeddedDatabase getDataSource() {

		return new EmbeddedDatabaseBuilder()
				.setType(EmbeddedDatabaseType.H2)
				.setName("nxrg;MODE=MySQL")
                .addScripts(
                        "09_submissionset.sql",
                        "10_documententry.sql",
                        "11_folder.sql",
                        "12_association.sql",
                        "21_documententry_author.sql",
                        "23_documententry_eventcode.sql",
                        "24_documententry_confidentialitycode.sql",
                        "26_documententry_referenceid.sql",
                        "30_alter_uniqueid.sql",
                        "31_indexes_for_searchable_fields.sql",
                        "35_add_upper_to_searchable_dates.sql",
                        "36_index_for_documententries_logicaluuid.sql",
                        "40_notnull_documententry_practisesettingcode.sql",
                        "41_index_for_documententries_patientid_availabilitystatus.sql",
                        "50_deletestatus.sql"
                )
				.build();
	}
}	
