package dk.nsp.xdscleanup.config;

import javax.sql.DataSource;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.datasource.DataSourceTransactionManager;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import dk.nsp.xdscleanup.service.RepositoryCleanupService;
import dk.nsp.xdscleanup.service.impl.RepositoryCleanupServiceImpl;

@Configuration
@EnableTransactionManagement
public class OpenXdsCleanupConfiguration {

	
	private DataSource dataSource;
	
	public OpenXdsCleanupConfiguration(@Autowired @Qualifier("openxdsDataSource") DataSource dataSource) {
		this.dataSource = dataSource;
	}
	
    @Bean(name="tx-openxds")
    public PlatformTransactionManager getTransactionManager() {
        return new DataSourceTransactionManager(dataSource);
    }
    
    @Bean
    public RepositoryCleanupService repositoryCleanupService() {
    	return new RepositoryCleanupServiceImpl();
    }
}
